
public class BenutzerVerwalterL {

  //private int maxBenutzerzahl = 100;
  //private int aktBenutzerzahl = 0;
  private int maxPIN = 0;
  private List<Benutzer> benutzerDaten;

  public BenutzerVerwalterL() {
    benutzerDaten = new List<Benutzer>();
  }

  public String gibVersion() {
    return "L: Liste nach PIN sortiert";
  }

  private String erzeugePIN() {
    int intervall = 100;
    int zufallszahl = (int) (Math.random()*intervall) + 1;
    maxPIN = maxPIN + zufallszahl;   
    String pin = "" + maxPIN;
    if (pin.length() == 1) {
      pin = "000"+pin;
    }
    if (pin.length() == 2) {
      pin = "00"+pin;
    }
    if (pin.length() == 3) {
      pin = "0"+pin;
    }
    return pin;
  }

  public void neuerBenutzer(String pName) {
    boolean vorhanden;
    String pin;
    Benutzer b = null;
    do {
      pin = erzeugePIN();
      if (! benutzerDaten.isEmpty()) {
        b = suchePIN(pin); 
      }
      if (b == null) {
        vorhanden = false; 
      } else {
        vorhanden = true;
      }
    } while (vorhanden); 
    if (!vorhanden) {
      eintragen(pName,pin);
      //System.out.println(pName+" "+pin+" anzahl: "+aktBenutzerzahl);
    }
  }

  public void beispielBelegung() {
    for (int i = 0; i < 1000; i++) {
      neuerBenutzer("a"+i);
    }
  }

  private int pinNr(String pPIN) {
    return Integer.parseInt(pPIN);
  }

  private void eintragen(String pName, String pPIN) {
    Benutzer neu = new Benutzer(pName,pPIN);
    benutzerDaten.append(neu);
  }

  public Benutzer sucheName(String pName) {
    boolean gefunden = false;
    benutzerDaten.toFirst();
    while (gefunden == false && benutzerDaten.hasAccess()) {
      Benutzer b = benutzerDaten.getContent();
      if (b != null && b.gibName().equals(pName)) {
        gefunden = true;
      } else {
        benutzerDaten.next();
      }
    }
    if (gefunden) {
      return benutzerDaten.getContent();
    } else {
      return null;
    }
  }

  public Benutzer suchePIN(String pPIN) {
    boolean gefunden = false;
    boolean weiter = true;
    benutzerDaten.toFirst();
    while (!gefunden && weiter && benutzerDaten.hasAccess()) {
      Benutzer b = benutzerDaten.getContent();
      if (b.gibPIN().equals(pPIN)) {
        gefunden = true;
      } else {
        benutzerDaten.next();
      }
      if (pPIN.compareTo(b.gibPIN()) < 0) {
        weiter = false;
      }
    }
    if (gefunden) {
      return benutzerDaten.getContent();
    } else {
      return null;
    }
  }

}

