import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

// Autor: %AUTHOR%
// Datum: %DATE%

public class BenutzerverwalterGUI extends JFrame {
  // Anfang Attribute
  private JLabel labPINGenerator = new JLabel();
  private JLabel labBenutzerId = new JLabel();
  private JLabel labPin = new JLabel();
  private JTextField tfBenutzerID = new JTextField();
  private JTextField tfPin = new JTextField();
  private JButton btId = new JButton();
  private JButton btPin = new JButton();
  private JButton btNeuesVerzeichnis = new JButton();
  private JButton btergaenzen = new JButton();
  private JLabel labVersion = new JLabel();
  // Ende Attribute
  private BenutzerVerwalterL generator = new BenutzerVerwalterL();

  public BenutzerverwalterGUI(String title) { 
    // Frame-Initialisierung
    super(title);
    setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
    int frameWidth = 310; 
    int frameHeight = 310;
    setSize(frameWidth, frameHeight);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    int x = (d.width - getSize().width) / 2;
    int y = (d.height - getSize().height) / 2;
    setLocation(x, y);
    setResizable(false);
    Container cp = getContentPane();
    cp.setLayout(null);
    // Anfang Komponenten

    labPINGenerator.setBounds(16, 8, 110, 20);
    labPINGenerator.setText("PIN Generator");
    cp.add(labPINGenerator);
    labBenutzerId.setBounds(16, 40, 110, 20);
    labBenutzerId.setText("Benutzername/ Id");
    cp.add(labBenutzerId);
    labPin.setBounds(16, 72, 110, 20);
    labPin.setText("PIN");
    cp.add(labPin);
    tfBenutzerID.setBounds(144, 40, 150, 20);
    cp.add(tfBenutzerID);
    tfPin.setBounds(144, 72, 150, 20);
    cp.add(tfPin);
    btId.setBounds(16, 104, 110, 25);
    btId.setText("Suche: Name");
    btId.setMargin(new Insets(2, 2, 2, 2));
    btId.addActionListener(new ActionListener() { 
        public void actionPerformed(ActionEvent evt) { 
          btId_ActionPerformed(evt);
        }
      });
    cp.add(btId);
    btPin.setBounds(176, 104, 110, 25);
    btPin.setText("Suche: PIN");
    btPin.setMargin(new Insets(2, 2, 2, 2));
    btPin.addActionListener(new ActionListener() { 
        public void actionPerformed(ActionEvent evt) { 
          btPin_ActionPerformed(evt);
        }
      });
    cp.add(btPin);
    btNeuesVerzeichnis.setBounds(16, 152, 267, 25);
    btNeuesVerzeichnis.setText("erzeuge Beispieldaten");
    btNeuesVerzeichnis.setMargin(new Insets(2, 2, 2, 2));
    btNeuesVerzeichnis.addActionListener(new ActionListener() { 
        public void actionPerformed(ActionEvent evt) { 
          btNeuesVerzeichnis_ActionPerformed(evt);
        }
      });
    cp.add(btNeuesVerzeichnis);
    btergaenzen.setBounds(16, 192, 267, 25);
    btergaenzen.setText("ergaenze Benutzer");
    btergaenzen.setMargin(new Insets(2, 2, 2, 2));
    btergaenzen.addActionListener(new ActionListener() { 
        public void actionPerformed(ActionEvent evt) { 
          btergaenzen_ActionPerformed(evt);
        }
      });
    cp.add(btergaenzen);
    labVersion.setBounds(16, 232, 262, 20);
    labVersion.setText("Version");
    cp.add(labVersion);
    // Ende Komponenten

    setVisible(true);
    labVersion.setText(generator.gibVersion());
  } // end of public PINGeneratorGUI

  // Anfang Methoden
  public void btId_ActionPerformed(ActionEvent evt) {
    String pin, name;
    name = tfBenutzerID.getText();
    Benutzer b = generator.sucheName(name);
    if (b != null) {
      tfPin.setText(b.gibPIN());
    }else {
      tfPin.setText("---"); 
    }

  } // end of btId_ActionPerformed
  public void btPin_ActionPerformed(ActionEvent evt) {
    String pin;
    pin = tfPin.getText();
    Benutzer b = generator.suchePIN(pin); 
    if (b != null) {
      tfBenutzerID.setText(b.gibName());
    } else {
      tfBenutzerID.setText("---"); 
    }
  } // end of btPin_ActionPerformed

  public void btNeuesVerzeichnis_ActionPerformed(ActionEvent evt) {
    generator.beispielBelegung();

  } // end of btNeuesVerzeichnis_ActionPerformed
  public void btergaenzen_ActionPerformed(ActionEvent evt) {
    String name = tfBenutzerID.getText();
    Benutzer b = generator.sucheName(name);
    if (b == null) {
      generator.neuerBenutzer(name);
    } else {
      tfPin.setText("bereits vorhanden");
    }
  } // end of btergaenzen_ActionPerformed

  // Ende Methoden

  public static void main(String[] args) {
    new BenutzerverwalterGUI("Benutzerverwalter fuer Kopierer");
  } // end of main

} // end of class PINGeneratorGUI
